Proud winner of ABECA 2024 - AmbitionBox Employee Choice Awards
Filter interviews by
I applied via Company Website and was interviewed in Feb 2022. There were 2 interview rounds.
5 or 6 questions from algo and coding
What people are saying about Google
I was interviewed before Nov 2020.
Round duration - 45 minutes
Round difficulty - Medium
The interview was with a Korean employee.
The brute force approach to find all the bridges in a given graph is to check for every edge if it is a bridge or not, by first not considering current edge is not in given graph and then checking if the vertices that it was connecting are still connected or not, using DFS(DepthFirst Search). Given below is an algorithm that will find all bridges in a graph.
Algorithm :
Round duration - 45 Minutes
Round difficulty - Medium
Interviewer was an Indian employee.
Round duration - 45 Minutes
Round difficulty - Hard
Interviewer was an Indian employee.
Approach:
Round duration - 45 Minutes
Round difficulty - Hard
Interviewer was an Indian employee.
The basic idea is to use modified Breadth-First Search (BFS) here. We can keep track of all the possible positions of the robot after ‘N’ instructions (N = 0, 1, 2, 3, 4, ...) and return the smallest ‘N’ such that the ‘TARGET’ position is reached
The steps are as follows:
Tip 1 : Do competitive coding in 1st and 2nd year.
Tip 2 : Practice basic questions before starting complex problem.
Tip 3 : Start doing mock interviews from the end of 5th semester. It gives a lot of confidence.
Tip 1 : Adding competitive programming ranks add value.
Tip 2 : You should have some good project which you can explain nicely.
Google interview questions for popular designations
I was interviewed in Oct 2020.
Round duration - 60 minutes
Round difficulty - Medium
Tip 1 : First think of the brute force approach and then optimise it .
Tip 2 : Analysis if problems is very important.
Tip 3 : First Question was of dynamic programming so I guess in such Questions recursive solution is easier and I would go for it.
Round duration - 100 minutes
Round difficulty - Medium
My interview was held from 3 to 3:50 and 4 to 4:50 in the evening . I sat in a silent place of my room with no disturbances in my room.
The interviewer first asked me to introduce myself then he did the same, he then gave me a problem of sliding window and we discussed to reach on a optimal solution then I wrote the code for it . Then he asked me to ask if I had any questions , I asked some questions regarding their work culture , what do they expect from me and what work will I be given there as an SDE -intern. Second interview was almost the same the problem was of dynamic programming .
Our intuition here is to go through each sliding window and keep track of the maximum element in each sliding window. To implement the same we run two nested loops, where the outer loop which will mark the starting point of the subarray of length k, the inner loop will run from the starting INDEX to INDEX + K, K elements from starting index and store the maximum element among these K elements into the answer...
Round duration - 50 minutes
Round difficulty - Medium
I have already given the description in the previous round.
For each possible combination of removing elements from the array, calculate the sum of the remaining elements. Finally, return the maximum sum calculated over all the possible ways.
The steps are as follows:
Tip 1 : Solve as many questions and learn as many concepts as you can from gfg and leetcode.
Tip 2 : Solve the questions on notepad or notebook because there you won't get an editor to point out your mistakes.
Tip 3 : Submit your code when you are completely satisfied because there you won't get to run and debug your code.
Tip 1 : Keep it 1 page short and catchy.
Tip 2 : Do not brag in your Resume your resume should be honest and should represent exactly what you are.
Get interview-ready with Top Google Interview Questions
I was interviewed in Oct 2020.
Round duration - 60 minutes
Round difficulty - Easy
Timing: Between 3-5 pm we could take the test anytime
The test environment was hackerrank. Great user interface and I did not suffer anyt problems.
There was no interviewer as it was coding test.
There were 2 coding questions asked.
The maximum possible OR of any subset is the OR of the whole array. So let the OR of the whole array be equal to ‘K’.
The idea is to generate all possible subsets and check if any of them OR up to ‘K’. This can be done through recursion.
Here is the algorithm:
subsetOR(N , ARR):
Store the dictionary words in a hash-map for a constant lookup time, now for each query word, try replacing each ‘?’ with every possible lowercase alphabet and generating all possible words that can be formed by the query word, for each of them: search whether it exists in the dictionary or not.
The steps are as follows:
Round duration - 45 minutes
Round difficulty - Medium
Timing was late at night ie 9:30 PM for this round.
The environment was nice. It was on Google meet.
The interviewer was very friendly and explained the question well
Approach: We can start the traversal of the paths from the rat’s starting position, i.e. (0,0) keeping track of the visited cells during the traversal. We will recursively go through all the paths possible until the last index of the grid (destination) is reached, and add the path information using which the rat successfully reached the end.
Algorithm is as follows:
Let us consider a function BFS that accepts a list of edges, EDGES, and the number of vertices VERTEX as a parameter and do:
Now, the function BF...
Tip 1 : Prepare core concepts well
Tip 2 : Practice medium level and hard questions
Tip 1 : Put good projects and experiences.
Tip 2 : Generally, don't put any false things on resume.
I was interviewed before Nov 2020.
Round duration - 60 Minutes
Round difficulty - Easy
How to align a text in a larger web page context?
OOPS Concepts
Round duration - 90 minutes
Round difficulty - Easy
Approach:
Now, let us understand how to break the big problem into small subproblems with an example let's say, for N = 2 and K = 3 and let the items be {R, G} we can see that this can be found out if:
Round duration - 60 Minutes
Round difficulty - Easy
Basic DBMS problems.
RDBMS vs Non RDBMS
Why SQL is very popular?
How do you get second largest salary
What is stored procedure?
Round duration - 30 Minutes
Round difficulty - Easy
He asked basic Database and oops questions and discussion about my projects.
Sleeping barber problem.
Disk scheduling algos
Process Scheduling algos
Turnaround time
Threads
Round duration - 50 Minutes
Round difficulty - Easy
It was evening. Since it was a telephonic interview so all at the home. NOthing different. About my soft skills, resume, and some basic coding stuff. Why google? Where do you see yourself in 5 years?
One basic approach is to explore all possible steps which can be climbed with either taking one step or two steps. So at every step, we have two options to climb the stairs either we can climb with one step, or we can climb with two steps. So the number of ways can be recursively defined as :
countDistinctWayToClimbStair ( currStep, N ) = countDistinctWayToClimbStair ( currStep+1, N ) + countDistinctWay...
Tip 1 : Over-communication is key
Tip 2 : Self-Advocacy and Initiative are twice as important when working virtually.
Tip 3 : Relaxed and Fresh
Tip 1 : Neat and clean. Use a professional font. Include only the most relevant information and put the most important information first. Use active language.
Tip 2 : Specific about the projects they required and your projects should be in bold.
I applied via Naukri.com and was interviewed before May 2022. There were 3 interview rounds.
Dsa questions started with arrays goes till graphs
I was interviewed in Sep 2020.
Round duration - 45 minutes
Round difficulty - Easy
Timing : Evening
In any rooted tree, the distance between two nodes 'U' and 'V' can be found by finding the lowest common ancestor (LCA), ‘x’ of two nodes. The lowest common ancestor (LCA) between nodes 'U' and 'V' is defined as the lowest node in the tree that has both 'U' and 'V' as descendants, where we define each node to be a descendant of itself (so if 'U' has a direct connection from 'V', 'V' is the lowest common a...
We do a depth-first traversal to travel the tree :
Round duration - 45 minutes
Round difficulty - Easy
Timing : 10:00 pm
The idea here is that we will do a recursive solution by asking the children of the current node for the max sum path and then choose the path with the max sum.
The approach will be as follows:
Al...
Round duration - 45 minutes
Round difficulty - Easy
Timimg : 11:00 pm
Approach:
A brute force solution to this problem is to turn on and off the bulbs N time, then at last check the number of bulbs that are on.
Algorithm:
Tip 1 : Practice as much you can
Tip 2 : Study Data Structures
Tip 3 : Be confident
Tip 1 : Mention only what you are confident about
Tip 2 : Mention tools & technologies used in the project as well
Some of the top questions asked at the Google interview for freshers -
The duration of Google interview process can vary, but typically it takes about less than 2 weeks to complete.
Interview experience
based on 1.8k reviews
Rating in categories
Software Engineer
1.3k
salaries
| ₹20 L/yr - ₹80 L/yr |
Software Developer
781
salaries
| ₹25.5 L/yr - ₹50.3 L/yr |
Senior Software Engineer
588
salaries
| ₹22 L/yr - ₹94 L/yr |
Sde1
252
salaries
| ₹16 L/yr - ₹64 L/yr |
Data Scientist
231
salaries
| ₹12 L/yr - ₹50 L/yr |
Yahoo
Amazon
Microsoft Corporation